Index: /inundation/ga/storm_surge/pmesh/documentation/issues.txt
===================================================================
--- /inundation/ga/storm_surge/pmesh/documentation/issues.txt	(revision 1152)
+++ /inundation/ga/storm_surge/pmesh/documentation/issues.txt	(revision 1153)
@@ -2,4 +2,160 @@
 
 OPEN - issues that have not beeen resolved
+Issue: If some triangles have tags and others don't then the data
+structure (a list of lists) is dificult to use in Numeric.
+ eg.
+SyntaxError: invalid syntax
+>>> a = array(['a','b']); print a
+[a b]
+>>> a = array(['a','b','']); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['b'],['']]); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['b'],['']]).astype(ListType); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['b'],['c']]).astype(ListType); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array(['a','b','']); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array(['a','b','c']); print a
+[a b c]
+>>> a = array([['a'],['b'],['c']]); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['a'],['a']]); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['a'],['a']]); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['a'],['a']], Character); print a
+[[  [a]]
+ [  [a]]
+ [  [a]]]
+>>> a = array([['a'],['a'],['']], Character); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a'],['a'],['','a']], Character); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array([['a','j'],['a','j'],['j','a']], Character); print a
+Traceback (most recent call last):
+  File "<stdin>", line 1, in ?
+TypeError: an integer is required
+>>> a = array(['a','a',''], Character); print a
+[[a]
+ [a]
+ [ ]]
+Solution -  use a list structure, instead of list of lists 
+ 
+
+Issue: Red mesh selected for refinement seems to be 'behind' the green
+mesh after selecting all then clearing the selection.
+Importance: low
+Suggested Action: Fixed BUT now it draws the greens behind the reds.
+It is much less obvious now though.
+
+
+Issue:  Ole thought that the regional mesh max areas were incorrect
+when a .tsh file was loaded.  Maybe it was that the overall max area
+is not saved.  It's hard coded in MeshGenDialog.
+Importance: Medium
+Suggested Action: Fix when .tsh goes NETCDF
+
+Issue: Catch error if .tsh file is a bad format.
+suggestion: quick and dirty try - except
+Importance: Medium
+
+Issue (new feature): Have visualisation of verts be turned on and
+off.  This will speed things up.
+Importance: low
+
+Issue (new feature): Hve .tsh as a netscf fie, instead of an ascii
+file.
+Importance: Medium
+
+Issue: When a file is saved as and then saved later, sometimes the
+file name is not known.   Is it that 'clear' is removing the name
+(which it should). 
+
+Issue:A .tsh file loaded into pmesh after smoothing will not have the
+outline info, since this is removed when smoothing.  If this is a
+problem, refactor loadASCII so it can write the outline as well.
+Suggested Action: Document use
+
+Issue:vertices at the bottom of the canvas can be hard to visualise,
+since you don't know if all vertices are on the screen.  
+Suggested Action: have a 5% border
+Importance: low to not do
+
+Issue: The mesh produced by triangle isn't of high quality near a low
+angle formed by two user segments.
+Reason:triangle
+Tried:  Tried the triangle flags L,i,V (for info).  Using box.poly on
+nautilus.  Couldn't get a better quality mesh.
+
+Issue: Get the naming right for mesh/triangulation/user/generated.
+How about "outline + triangulation = mesh"
+Importance: Medium -low
+
+Issue: S/W - too many methods with the same name on differnent classes
+eg editWindow.  Makes things confusing. 
+Importance: low
+
+Issue: Normalise seems broken - what is it doing to the attributes?.  
+Suggested Action: remove!
+
+Bug: Calling 'Generate Mesh' on empty document or If there are no
+enclosed regions will cause trianglulation to crash pmesh.
+Importance: low - not do, but document
+Suggested Action: Catch them (with try) and do nothing
+notes:   Fixing the 'Generate Mesh' crash is a P3 requirement.
+
+The zoom in/out is jittery
+
+The initial mesh window coordinates are in the fourth quadrant.
+
+Deleting a selected object is done with the scroll bar, not the 
+delete key. 
+
+Issue: triangle calculates incorrect attribute values, some of the time.
+Importance: Medium
+Suggested Action: Preprocess data to smoth it out.
+
+Issue: pmesh can not be automatically installed in windows and linux,
+triangle doesn't compile easily.
+Installs best in Linux.  
+Importance: Low
+Suggested Action: delve into setup more so it works with a variety of
+compilers.
+
+Issue: two vertices can be ontop of one another
+Importance: Low
+Suggested Action: See how it goes when used.  The cost of checking
+probably doesn't outwiegh the benifit.
+action taken: When loading an xya file duplicate vertices are removed. 
+
+
+Issue: When calculating mesh, have the pointer turn into an hour glass
+Importance: Low
+
+****************
+CLOSED - issues that have  beeen resolved
+************
 
 Issue (Ole): I couldn't get pmesh to write mesh in the .msh format
@@ -9,100 +165,6 @@
     2:  Allow pmesh to store as msh
     3:  Have a tsh2msh converter
-    
-
-Issue: Red mesh selected for refinement seems to be 'behind' the green
-mesh after selecting all then clearing the selection.
-Importance: low
-Suggested Action: Fixed BUT now it draws the greens behind the reds.
-It is much less obvious now though.
-
-
-Issue:  Ole thought that the regional mesh max areas were incorrect
-when a .tsh file was loaded.  Maybe it was that the overall max area
-is not saved.  It's hard coded in MeshGenDialog.
-Importance: Medium
-Suggested Action: Fix when .tsh goes NETCDF
-
-Issue: Catch error if .tsh file is a bad format.
-suggestion: quick and dirty try - except
-Importance: Medium
-
-Issue (new feature): Have visualisation of verts be turned on and
-off.  This will speed things up.
-Importance: low
-
-Issue (new feature): Hve .tsh as a netscf fie, instead of an ascii
-file.
-Importance: Medium
-
-Issue: When a file is saved as and then saved later, sometimes the
-file name is not known.   Is it that 'clear' is removing the name
-(which it should). 
-
-Issue:A .tsh file loaded into pmesh after smoothing will not have the
-outline info, since this is removed when smoothing.  If this is a
-problem, refactor loadASCII so it can write the outline as well.
-Suggested Action: Document use
-
-Issue:vertices at the bottom of the canvas can be hard to visualise,
-since you don't know if all vertices are on the screen.  
-Suggested Action: have a 5% border
-Importance: low to not do
-
-Issue: The mesh produced by triangle isn't of high quality near a low
-angle formed by two user segments.
-Reason:triangle
-Tried:  Tried the triangle flags L,i,V (for info).  Using box.poly on
-nautilus.  Couldn't get a better quality mesh.
-
-Issue: Get the naming right for mesh/triangulation/user/generated.
-How about "outline + triangulation = mesh"
-Importance: Medium -low
-
-Issue: S/W - too many methods with the same name on differnent classes
-eg editWindow.  Makes things confusing. 
-Importance: low
-
-Issue: Normalise seems broken - what is it doing to the attributes?.  
-Suggested Action: remove!
-
-Bug: Calling 'Generate Mesh' on empty document or If there are no
-enclosed regions will cause trianglulation to crash pmesh.
-Importance: low - not do, but document
-Suggested Action: Catch them (with try) and do nothing
-notes:   Fixing the 'Generate Mesh' crash is a P3 requirement.
-
-The zoom in/out is jittery
-
-The initial mesh window coordinates are in the fourth quadrant.
-
-Deleting a selected object is done with the scroll bar, not the 
-delete key. 
-
-Issue: triangle calculates incorrect attribute values, some of the time.
-Importance: Medium
-Suggested Action: Preprocess data to smoth it out.
-
-Issue: pmesh can not be automatically installed in windows and linux,
-triangle doesn't compile easily.
-Installs best in Linux.  
-Importance: Low
-Suggested Action: delve into setup more so it works with a variety of
-compilers.
-
-Issue: two vertices can be ontop of one another
-Importance: Low
-Suggested Action: See how it goes when used.  The cost of checking
-probably doesn't outwiegh the benifit.
-action taken: When loading an xya file duplicate vertices are removed. 
-
-
-Issue: When calculating mesh, have the pointer turn into an hour glass
-Importance: Low
-
-****************
-CLOSED - issues that have  beeen resolved
-************
-
+Closed: Couldn't be reproduced. suggested action 2 has already been
+implemented.  More investigation required before calling an issue an issue..
 
 Issue: After selecting all for refinement then clearing the selection